/*

Copyright Yann OLLIVIER 1997-1999

This software may be freely distributed as is, including
this whole notice.

It may be modified, but any modification should include this whole notice as 
is and a description of the changes made.

This software may not be sold.

This software or any modified version of it may be freely used in free
programs. The program should include a copy of this whole notice. If you
want to use it in a program you sell, contact me

This software comes with absolutely no warranty.

*/

//#include <gtk/gtk.h>
#include "eqdiff.h"
//#include "afaire.h"

DC::DC(Fenetre* fenetrep)
{
  fenetre=fenetrep;
  gc=gdk_gc_new(fenetre->window->window);
}

DC::~DC()
{
  gdk_gc_destroy(gc);
  delete drawable;
}

void SelectObject(HDC dc,HPEN pen)
{
  GdkGCValues val;
  gdk_gc_get_values(dc->gc,&val);
  gdk_gc_set_foreground(dc->gc,&pen->color);
  gdk_color_alloc(gtk_widget_get_colormap(dc->fenetre->drawing_area),&pen->color);
  gdk_gc_set_line_attributes(dc->gc,pen->width,val.line_style,val.cap_style,val.join_style);
}

HPEN CreatePen(GdkLineStyle style,gint width,GdkColor color)
{
  HPEN hp=new Pen;
  hp->style=style;hp->width=width;hp->color=color;
  return hp;
}

void DeleteObject(HPEN hp)
{delete hp;}

GdkColor RGB(int red,int green,int blue)
{
  GdkColor color;
  color.red=red;
  color.green=green;
  color.blue=blue;
  color.pixel = (gulong)(red*256 + green + blue/256);
  return color;
}

int operator==(GdkColor c1,GdkColor c2)
{return (c1.red==c2.red&&c1.green==c2.green&&c1.blue==c2.blue);}

int operator!=(GdkColor c1,GdkColor c2)
{return (!(c1.red==c2.red&&c1.green==c2.green&&c1.blue==c2.blue));}

GdkFunction SelectFunction(HDC dc,GdkFunction function)
{
  GdkGCValues val;
  gdk_gc_get_values(dc->gc,&val);
  gdk_gc_set_function(dc->gc,function);
  return val.function;
}

void Go(HDC dc,double x,double y)
{
  dc->xcurr=dc->fenetre->xphys(x);dc->ycurr=dc->fenetre->yphys(y);
  //  gdk_draw_point(*dc->drawable,dc->gc,dc->xcurr,dc->ycurr);
}

void Line(HDC dc,double x,double y)
{
  gint xcurr2,ycurr2;
  xcurr2=dc->fenetre->xphys(x);ycurr2=dc->fenetre->yphys(y);
  gdk_draw_line(*dc->drawable,dc->gc,dc->xcurr,dc->ycurr,
		xcurr2,ycurr2);
  dc->xcurr=xcurr2;dc->ycurr=ycurr2;
}

void Line(HDC dc,double x1,double y1,double x2,double y2)
{
  dc->xcurr=dc->fenetre->xphys(x2);dc->ycurr=dc->fenetre->yphys(y2);
  gdk_draw_line(*dc->drawable,dc->gc,dc->fenetre->xphys(x1),dc->fenetre->yphys(y1),dc->xcurr,dc->ycurr);
}

void Go(HDC dc,long int x,long int y)
{
  dc->xcurr=x;dc->ycurr=y;
  //  gdk_draw_point(*dc->drawable,dc->gc,dc->xcurr,dc->ycurr);
}

void Line(HDC dc,long int x,long int y)
{
  gdk_draw_line(*dc->drawable,dc->gc,dc->xcurr,dc->ycurr,x,y);
  dc->xcurr=x;dc->ycurr=y;
}

void Line(HDC dc,long int x1,long int y1,long int x2,long int y2)
{
  dc->xcurr=x2;dc->ycurr=y2;
  gdk_draw_line(*dc->drawable,dc->gc,x1,y1,x2,y2);
}

InputDialogClass::InputDialogClass()
{
  window=gtk_window_new(GTK_WINDOW_TOPLEVEL);
  GtkWidget *vbox,*hbox,*button;
  vbox=gtk_vbox_new(FALSE,5);
  gtk_container_border_width(GTK_CONTAINER(vbox),5);
  gtk_container_add(GTK_CONTAINER(window),vbox);
  gtk_widget_show(vbox);
  hbox=gtk_hbox_new(FALSE,0);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,TRUE,0);
  gtk_widget_show(hbox);
  label=gtk_label_new("");
  gtk_box_pack_start(GTK_BOX(hbox),label,FALSE,FALSE,0);
  gtk_widget_show(label);
  hbox=gtk_hbox_new(FALSE,0);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,TRUE,0);
  gtk_widget_show(hbox);
  entry=gtk_entry_new();
  gtk_box_pack_start(GTK_BOX(hbox),entry,FALSE,FALSE,0);
  gtk_widget_show(entry);
  hbox=gtk_hbox_new(FALSE,0);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,TRUE,5);
  gtk_widget_show(hbox);
  button=gtk_button_new_with_label("OK");
  gtk_box_pack_start(GTK_BOX(hbox),button,TRUE,TRUE,0);
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC (InputDialOK),this);
  gtk_widget_show(button);
  button=gtk_button_new_with_label("Cancel");
  gtk_box_pack_start(GTK_BOX(hbox),button,TRUE,TRUE,0);
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC (InputDialCancel),this);
  gtk_signal_connect (GTK_OBJECT (window), "delete_event",
		      GTK_SIGNAL_FUNC (InputDialCancel),this);
  gtk_signal_connect(GTK_OBJECT(entry),"activate",
		     GTK_SIGNAL_FUNC(InputDialOK),this);
  gtk_widget_show(button);
  Ind=-1;
}

int InputDialog(char*title,char*prompt,char*init,char**destp)
{
  static InputDialogClass* InputDial=NULL;
  if(InputDial==NULL)InputDial=new InputDialogClass;
  gtk_window_set_title(GTK_WINDOW(InputDial->window),title);
  gtk_label_set_text(GTK_LABEL(InputDial->label),prompt);
  if(init==NULL)gtk_entry_set_text(GTK_ENTRY(InputDial->entry),"");
  else gtk_entry_set_text(GTK_ENTRY(InputDial->entry),init);
  InputDial->dest=destp;InputDial->Ind=-1;
  gtk_grab_add(InputDial->window);
  gtk_widget_grab_focus(InputDial->entry);
  gtk_widget_show(InputDial->window);
  while (InputDial->Ind==-1)gtk_main_iteration();
  gtk_widget_hide(InputDial->window);
  return InputDial->Ind;
}

void InputDialOK(GtkWidget*,gpointer pointer)
{
  InputDialogClass*InputDial=(InputDialogClass*)pointer;
  InputDial->Ind=InputDialog_OK;;
  *InputDial->dest=gtk_entry_get_text(GTK_ENTRY(InputDial->entry));
  gtk_grab_remove(InputDial->window);
}
void InputDialCancel(GtkWidget*,gpointer pointer)
{
  InputDialogClass*InputDial=(InputDialogClass*)pointer;
  InputDial->Ind=InputDialog_Cancel;
  gtk_grab_remove(InputDial->window);
}

AskDialogClass::AskDialogClass()
{
  window=gtk_window_new(GTK_WINDOW_TOPLEVEL);
  GtkWidget *vbox,*hbox,*button;
  vbox=gtk_vbox_new(FALSE,5);
  gtk_container_border_width(GTK_CONTAINER(vbox),5);
  gtk_container_add(GTK_CONTAINER(window),vbox);
  gtk_widget_show(vbox);
  hbox=gtk_hbox_new(FALSE,0);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,TRUE,0);
  gtk_widget_show(hbox);
  label=gtk_label_new("");
  gtk_box_pack_start(GTK_BOX(hbox),label,FALSE,FALSE,0);
  gtk_widget_show(label);
  hbox=gtk_hbox_new(FALSE,0);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,TRUE,5);
  gtk_widget_show(hbox);
  button=gtk_button_new_with_label("Yes");
  gtk_box_pack_start(GTK_BOX(hbox),button,TRUE,TRUE,0);
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC (AskDialYes),this);
  gtk_widget_show(button);
  button=gtk_button_new_with_label("No");
  gtk_box_pack_start(GTK_BOX(hbox),button,TRUE,TRUE,0);
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC (AskDialNo),this);
  gtk_signal_connect (GTK_OBJECT (window), "delete_event",
		      GTK_SIGNAL_FUNC (AskDialNo),this);
  gtk_widget_show(button);
  Ind=-1;
}

int AskDialog(char*title,char*prompt)
{
  static AskDialogClass* AskDial=NULL;
  if(AskDial==NULL)AskDial=new AskDialogClass;
  gtk_window_set_title(GTK_WINDOW(AskDial->window),title);
  gtk_label_set_text(GTK_LABEL(AskDial->label),prompt);
  gtk_grab_add(AskDial->window);
  gtk_widget_show(AskDial->window);AskDial->Ind=-1;
  while (AskDial->Ind==-1)gtk_main_iteration();
  gtk_widget_hide(AskDial->window);
  return AskDial->Ind;
}

void AskDialYes(GtkWidget*,gpointer pointer)
{
  AskDialogClass*AskDial=(AskDialogClass*)pointer;
  AskDial->Ind=AskDialog_Yes;
  gtk_grab_remove(AskDial->window);
}

void AskDialNo(GtkWidget*,gpointer pointer)
{
  AskDialogClass*AskDial=(AskDialogClass*)pointer;
  AskDial->Ind=AskDialog_No;
  gtk_grab_remove(AskDial->window);
}

MessageBoxClass::MessageBoxClass()
{
  window=gtk_window_new(GTK_WINDOW_TOPLEVEL);
  GtkWidget *vbox,*hbox,*button;
  vbox=gtk_vbox_new(FALSE,5);
  gtk_container_border_width(GTK_CONTAINER(vbox),5);
  gtk_container_add(GTK_CONTAINER(window),vbox);
  gtk_widget_show(vbox);
  hbox=gtk_hbox_new(FALSE,0);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,TRUE,0);
  gtk_widget_show(hbox);
  label=gtk_label_new("");
  gtk_box_pack_start(GTK_BOX(hbox),label,FALSE,FALSE,0);
  gtk_widget_show(label);
  hbox=gtk_hbox_new(FALSE,0);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,TRUE,5);
  gtk_widget_show(hbox);
  button=gtk_button_new_with_label("OK");
  gtk_box_pack_start(GTK_BOX(hbox),button,TRUE,TRUE,0);
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC (MessageBoxDialYes),this);
  gtk_widget_show(button);
  gtk_signal_connect (GTK_OBJECT (window), "delete_event",
		      GTK_SIGNAL_FUNC (MessageBoxDialYes),this);
  Ind=-1;
}

void MessageBox(char*title,char*prompt)
{
  static MessageBoxClass* MessageBoxDial=NULL;
  if(MessageBoxDial==NULL)MessageBoxDial=new MessageBoxClass;
  gtk_window_set_title(GTK_WINDOW(MessageBoxDial->window),title);
  gtk_label_set_text(GTK_LABEL(MessageBoxDial->label),prompt);
  gtk_grab_add(MessageBoxDial->window);
  gtk_widget_show(MessageBoxDial->window);MessageBoxDial->Ind=-1;
  while (MessageBoxDial->Ind==-1)gtk_main_iteration();
  gtk_widget_hide(MessageBoxDial->window);
  return;
}

void MessageBoxDialYes(GtkWidget*,gpointer pointer)
{
  MessageBoxClass*MessageBoxDial=(MessageBoxClass*)pointer;
  MessageBoxDial->Ind=1;
  gtk_grab_remove(MessageBoxDial->window);
}

FileSelDialogClass::FileSelDialogClass()
{
  window=gtk_file_selection_new("Choose a file");
  gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION(window)->ok_button), "clicked",
		      GTK_SIGNAL_FUNC (FileSelDialOK),this);
  gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION(window)->cancel_button), "clicked",
		      GTK_SIGNAL_FUNC (FileSelDialCancel),this);
  gtk_signal_connect (GTK_OBJECT (window), "delete_event",
		      GTK_SIGNAL_FUNC (FileSelDialCancel),this);
  Ind=-1;
}

char* FileSelDialog()
{
  static FileSelDialogClass* FileSelDial=NULL;
  if(FileSelDial==NULL)FileSelDial=new FileSelDialogClass;
  gtk_grab_add(FileSelDial->window);
  gtk_widget_show(FileSelDial->window);FileSelDial->Ind=-1;
  while (FileSelDial->Ind==-1)gtk_main_iteration();
  gtk_widget_hide(FileSelDial->window);
  if(FileSelDial->Ind==FileSelDialog_OK)
    return gtk_file_selection_get_filename(GTK_FILE_SELECTION(FileSelDial->window));
  return NULL;
}

void FileSelDialOK(GtkWidget*,FileSelDialogClass*FileSelDial)
{
  FileSelDial->Ind=FileSelDialog_OK;
  gtk_grab_remove(FileSelDial->window);
}

void FileSelDialCancel(GtkWidget*,FileSelDialogClass*FileSelDial)
{
  FileSelDial->Ind=FileSelDialog_Cancel;
  gtk_grab_remove(FileSelDial->window);
}
