/*

Copyright Yann OLLIVIER 1997-1999

This software may be freely distributed as is, including
this whole notice.

It may be modified, but any modification should include this whole notice as 
is and a description of the changes made.

This software may not be sold.

This software or any modified version of it may be freely used in free
programs. The program should include a copy of this whole notice. If you
want to use it in a program you sell, contact me

This software comes with absolutely no warranty.

*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <gtk/gtk.h>

#include "../mathexpr.h"
#include "eqdiff.h"

void TCourbe::AjouteDeb(double x,double y,double t)
{
  TPoint*prem2=prem;prem=new TPoint;if(prem2!=NULL)prem2->prec=prem;
  prem->prec=NULL;prem->succ=prem2;prem->x=x;prem->y=y;prem->t=t;
}

void TCourbe::AjouteFin(double x,double y,double t)
{
  if(prem==NULL){prem=new TPoint;prem->prec=prem->succ=NULL;
  prem->x=x;prem->y=y;prem->t=t;return;};
  TPoint*ppoint;for(ppoint=prem;ppoint->succ!=NULL;ppoint=ppoint->succ);
  TPoint*pp2=new TPoint;ppoint->succ=pp2;pp2->prec=ppoint;pp2->succ=NULL;
  pp2->x=x;pp2->y=y;pp2->t=t;
}

void TCourbe::Detruit()
{
  TPoint*ppoint,*ppoint2;
  for(ppoint=prem;ppoint!=NULL;){
    ppoint2=ppoint;ppoint=ppoint->succ;delete ppoint2;};
}

TCourbe::TCourbe(const TCourbe&crb)
{
  if(crb.prem==NULL)prem=NULL;else{
    TPoint*ppoint,*ppoint2=crb.prem;
    prem=new TPoint;prem->x=ppoint2->x;prem->y=ppoint2->y;prem->t=ppoint2->t;
    for(ppoint=prem,ppoint2=ppoint2->succ;ppoint2!=NULL;ppoint2=ppoint2->succ){
      ppoint->succ=new TPoint;ppoint=ppoint->succ;
      ppoint->x=ppoint2->x;ppoint->y=ppoint2->y;ppoint->t=ppoint2->t;
    };
    ppoint->succ=NULL;
  };
}

TCourbe TCourbe::operator=(TCourbe crb)
{
  Detruit();
  if(crb.prem==NULL)prem=NULL;else{
    TPoint*ppoint,*ppoint2=crb.prem;
    prem=new TPoint;prem->x=ppoint2->x;prem->y=ppoint2->y;prem->t=ppoint2->t;
    for(ppoint=prem,ppoint2=ppoint2->succ;ppoint2!=NULL;ppoint2=ppoint2->succ){
      ppoint->succ=new TPoint;ppoint=ppoint->succ;
      ppoint->x=ppoint2->x;ppoint->y=ppoint2->y;ppoint->t=ppoint2->t;
    };
    ppoint->succ=NULL;
  };
  return *this;
}

//char Analyse(TFonction*,double,double,
//	double,double,double&,double&){return 0;}

char Fenetre::TestePoint(TCourbe*pcrb,double x,double y,double dr)
{
  TPoint*ppoint;
  for(ppoint=pcrb->prem;ppoint!=NULL&&
	((x-ppoint->x)*(x-ppoint->x)/(xech*xech)+(y-ppoint->y)*(y-ppoint->y)/(yech*yech))>dr*dr
	;ppoint=ppoint->succ);
  return(ppoint==NULL?0:1);
}

double Fenetre::TestePointLim(double x,double y,double dr)
{
  int k;double dd=1E2000,dd2;TPoint*ppoint;
  for(k=0;k<!LCourbesLim;k++){
    for(ppoint=LCourbesLim[k].prem;ppoint!=NULL;ppoint=ppoint->succ){
      dd2=((x-ppoint->x)*(x-ppoint->x)/(xech*xech)+(y-ppoint->y)*(y-ppoint->y)/(yech*yech));
      if(dd2<=dr*dr)return 0;
      dd=(dd>dd2?dd2:dd);
    };
  };
  return sqrt(dd);	
}

void Fenetre::CalculeFonction(TFonction*f)
{
  if(f->pexpr==NULL||f->Diff)return;
  ActivateWait();
  switch(f->t){
  case 0:CalculeFonctionX(f);break;
  case 1:CalculeFonctionY(f);break;
  case 3:CalculeFonctionA(f);break;
  case 4:CalculeFonctionR(f);break;
  case 2:CalculeFonctionXYFT(f);break;
  case 5:CalculeFonctionRAFT(f);break;
  };
  DeactivateWait();
}

void Fenetre::CalculeFonctionX(TFonction*f)
{
  f->LCourbes.Destroy();
  if(f->minp==ErrVal)xmin=xlc-xech;else xmin=(xlc-xech<f->minp?f->minp:xlc-xech);
  if(f->maxp==ErrVal)xmax=xlc+xech;else xmax=(xlc+xech>f->maxp?f->maxp:xlc+xech);
  double dy,dy2,xg=xmin,x0,y0,dr=f->dr,dl=1/xech,x1=xmin-xech,s;
  PROperation pexpr=f->pexpr,pexprder=f->pexprder;
  TCourbe*pcrb;
  for(x=xmin;x<xmax;x+=dr*xech)if((y=pexpr->Val())!=ErrVal&&y<ylc+yech&&y>ylc-yech){
    pcrb=new TCourbe;f->LCourbes.AddObject(pcrb);x0=x;y0=y;
    for(dy=dy2=s=0;x!=x1&&y<ylc+yech&&y>ylc-yech&&x>xg&&dy!=ErrVal&&y!=ErrVal
	  &&((dy>=0&&dy2>=0)||(dy<=0&&dy2<=0)||fabs(dy-dy2)<dl);
	dy2=dy,dy=pexprder->Val(),dy=(dy==ErrVal?0:dy/yech),x1=x,
	  x-=dr/hypot(1/xech,dy),y=pexpr->Val(),
	  s-=dr*hypot(1,yech*dy)/hypot(1/xech,dy))
      {pcrb->AjouteDeb(x,y,s);
      if(InterruptionToRepeat())goto fin;};
    for(x=x0,y=y0,dy=dy2=s=0;x!=x1&&y<ylc+yech&&y>ylc-yech&&x<xmax&&dy!=ErrVal&&y!=ErrVal
	  &&((dy>=0&&dy2>=0)||(dy<=0&&dy2<=0)||fabs(dy-dy2)<dl);
	dy2=dy,dy=pexprder->Val(),dy=(dy==ErrVal?0:dy/yech),x1=x,
	  x+=dr/hypot(1/xech,dy),y=pexpr->Val(),
	  s+=dr*hypot(1,yech*dy)/hypot(1/xech,dy)){
      pcrb->AjouteFin(x,y,s);
      if(InterruptionToRepeat())goto fin;};
    xg=x-dr*xech;x1=xg;
  };
 fin:f->Calc=1;
}

void Fenetre::CalculeFonctionY(TFonction*f)
{
  f->LCourbes.Destroy();
  if(f->minp==ErrVal)ymin=ylc-yech;else ymin=(ylc-yech<f->minp?f->minp:ylc-yech);
  if(f->maxp==ErrVal)ymax=ylc+yech;else ymax=(ylc+yech>f->maxp?f->maxp:ylc+yech);
  double dx,dx2,yg=ymin,y0,x0,dr=f->dr,dl=1/yech,y1=ymin-yech,s;
  PROperation pexpr=f->pexpr,pexprder=f->pexprder;
  TCourbe*pcrb;
  for(y=ymin;y<ymax;y+=dr*yech)if((x=pexpr->Val())!=ErrVal&&x<xlc+xech&&x>xlc-xech){
    pcrb=new TCourbe;f->LCourbes.AddObject(pcrb);y0=y;x0=x;
    for(dx=dx2=s=0;y!=y1&&x<xlc+xech&&x>xlc-xech&&y>yg&&dx!=ErrVal&&x!=ErrVal
	  &&((dx>=0&&dx2>=0)||(dx<=0&&dx2<=0)||fabs(dx-dx2)<dl);
	dx2=dx,dx=pexprder->Val(),dx=(dx==ErrVal?0:dx/xech),y1=y,
	  y-=dr/hypot(1/yech,dx),x=pexpr->Val(),
	  s-=dr*hypot(1,xech*dx)/hypot(1/yech,dx))
      {pcrb->AjouteDeb(x,y,s);
            if(InterruptionToRepeat())goto fin;};
    for(y=y0,x=x0,dx=dx2=s=0;x<xlc+xech&&x>xlc-xech&&y<ymax&&dx!=ErrVal&&x!=ErrVal
	  &&((dx>=0&&dx2>=0)||(dx<=0&&dx2<=0)||fabs(dx-dx2)<dl);
	dx2=dx,dx=pexprder->Val(),dx=(dx==ErrVal?0:dx/xech),y1=y,
	  y+=dr/hypot(1/yech,dx),x=pexpr->Val(),
	  s+=dr*hypot(1,xech*dx)/hypot(1/yech,dx))
      {pcrb->AjouteFin(x,y,s);
            if(InterruptionToRepeat())goto fin;};
    yg=y-dr*yech;y1=yg;
  };
 fin:f->Calc=1;
}

double Fenetre::PolarEch()
{double s=sin(a),c=cos(a);
return(xech*xech*s*s+yech*yech*c*c);
}
double Fenetre::RMax()
{double rmax=0,r;
r=hypot(xlc-xech,ylc-yech);rmax=(rmax<r?r:rmax);
r=hypot(xlc+xech,ylc-yech);rmax=(rmax<r?r:rmax);
r=hypot(xlc-xech,ylc+yech);rmax=(rmax<r?r:rmax);
r=hypot(xlc+xech,ylc+yech);rmax=(rmax<r?r:rmax);
return rmax;}
double Fenetre::RMin()
{double rmin=1E4000L,r;
if((xlc-xech)*(xlc+xech)<=0){if((ylc-yech)*(ylc+yech)<=0)return 0;
	rmin=(rmin>xlc+xech?xlc+xech:rmin);
	rmin=(rmin>-xlc+xech?-xlc+xech:rmin);}
if((ylc-yech)*(ylc+yech)<=0){rmin=(rmin>ylc+yech?ylc+yech:rmin);
	rmin=(rmin>-ylc+yech?-ylc+yech:rmin);}
r=hypot(xlc-xech,ylc-yech);rmin=(rmin>r?r:rmin);
r=hypot(xlc+xech,ylc-yech);rmin=(rmin>r?r:rmin);
r=hypot(xlc-xech,ylc+yech);rmin=(rmin>r?r:rmin);
r=hypot(xlc+xech,ylc+yech);rmin=(rmin>r?r:rmin);
return rmin;
}
//vrifier dr!=ErrVal
void Fenetre::CalculeFonctionA(TFonction*f)
{
  f->LCourbes.Destroy();double amin,amax,rmin,rmax;
  amin=f->minp==ErrVal?0:f->minp;
  amax=f->maxp==ErrVal?2*3.1415926535897932384L:f->maxp;
  rmax=RMax();rmin=-rmax;
  double dr,dr2,ag=amin,a0,r0,dp=f->dr,da=dp,c,s,a1=amin-1,absc;
  PROperation pexpr=f->pexpr,pexprder=f->pexprder;
  TCourbe*pcrb;
  for(a=amin;a<amax;a+=dp)if((r=pexpr->Val())!=ErrVal&&r<rmax&&r>rmin){
    pcrb=new TCourbe;f->LCourbes.AddObject(pcrb);a0=a;r0=r;
    for(c=cos(a),s=sin(a),dr=dr2=absc=0;a!=a1&&r<rmax&&r>rmin&&a>ag&&dr!=ErrVal&&r!=ErrVal
	  &&((dr>=0&&dr2>=0)||(dr<=0&&dr2<=0)||fabs(dr-dr2)<1);
	dr2=dr,dr=pexprder->Val(),dr=(dr==ErrVal?0:dr/hypot(xech*c,yech*s)),
	  da=(r||dr?dp/sqrt(r*r/(xech*xech*s*s+yech*yech*c*c)+dr*dr):dp),
	  da=(da>dp?dp:da),a1=a,a-=da,
	  absc-=da*sqrt(r*r+dr*dr*(xech*c*xech*c+yech*s*yech*s)),
	  r=pexpr->Val(),c=cos(a),s=sin(a))
      {pcrb->AjouteDeb(r*c,r*s,absc);
      if(InterruptionToRepeat())goto fin;};
    for(a=a0,r=r0,dr=dr2=absc=0,c=cos(a),s=sin(a);a!=a1&&r<rmax&&r>rmin&&a<amax&&dr!=ErrVal&&r!=ErrVal
	  &&((dr>=0&&dr2>=0)||(dr<=0&&dr2<=0)||fabs(dr-dr2)<1);
	dr2=dr,dr=pexprder->Val(),dr=(dr==ErrVal?0:dr/hypot(xech*c,yech*s)),
	  da=(r||dr?dp/sqrt(r*r/(xech*xech*s*s+yech*yech*c*c)+dr*dr):dp),
	  da=(da>dp?dp:da),a1=a,a+=da,
	  absc+=da*sqrt(r*r+dr*dr*(xech*c*xech*c+yech*s*yech*s)),
	  c=cos(a),s=sin(a),r=pexpr->Val())
      {pcrb->AjouteFin(r*c,r*s,absc);
      if(InterruptionToRepeat())goto fin;};
    ag=a-(r!=0&&r!=ErrVal?dp*sqrt(PolarEch())/fabs(r):dp);a1=ag;
  };
 fin:f->Calc=1;
}

void Fenetre::CalculeFonctionR(TFonction*f)
{
  f->LCourbes.Destroy();double rmin,rmax;
  rmin=f->minp==ErrVal?RMin():f->minp;
  rmax=f->maxp==ErrVal?RMax():f->maxp;
  double da,da2,rg=rmin,r0,a0,dp=f->dr,dr=dp,c,s,pech1,r1=rmin-(rmax-rmin),absc;
  PROperation pexpr=f->pexpr,pexprder=f->pexprder;
  TCourbe*pcrb;
  for(r=rmin;r<rmax;r+=(a!=ErrVal?dp*hypot(xech*c,yech*s):dp*sqrt(xech*yech)))if((a=pexpr->Val())!=ErrVal){
    pcrb=new TCourbe;f->LCourbes.AddObject(pcrb);a0=a;r0=r;
    for(da=da2=absc=0;r!=r1&&r>rg&&da!=ErrVal&&a!=ErrVal
	  &&fabs(da*dp*(c=cos(a),s=sin(a),pech1=hypot(xech*c,yech*s)))<31.4
	  &&((da>=0&&da2>=0)||(da<=0&&da2<=0)||fabs((da-da2)*pech1)<1);
	da2=da,da=pexprder->Val(),r1=r,
	  dr=(da!=ErrVal?dp/sqrt(1/(pech1*pech1)+da*da*r*r/(xech*xech*s*s+yech*yech*c*c)):0),
	  absc-=(da==ErrVal?0:dr*hypot(1,da)),
	  r-=dr,a=pexpr->Val())
      {pcrb->AjouteDeb(r*c,r*s,absc);
      if(InterruptionToRepeat())goto fin;};
    for(a=a0,r=r0,da=da2=absc=0;r!=r1&&r<rmax&&da!=ErrVal&&a!=ErrVal
	  &&fabs(da*dp*(c=cos(a),s=sin(a),pech1=hypot(xech*c,yech*s)))<31.4
	  &&((da>=0&&da2>=0)||(da<=0&&da2<=0)||fabs((da-da2)*hypot(xech*c,yech*s))<1);
	da2=da,da=pexprder->Val(),r1=r,
	  dr=(da!=ErrVal?dp/sqrt(1/(pech1*pech1)+da*da*r*r/(xech*xech*s*s+yech*yech*c*c)):0),
	  absc+=(da==ErrVal?0:dr*hypot(1,da)),
	  r+=dr,a=pexpr->Val())
      {pcrb->AjouteFin(r*c,r*s,absc);
      if(InterruptionToRepeat())goto fin;};
    rg=r-dp*pech1;r1=rg;
  };
 fin:f->Calc=1;
}

void Fenetre::CalculeFonctionXYFT(TFonction*f)
{
  f->LCourbes.Destroy();double tmin,tmax;
  tmin=f->minp==ErrVal?0:f->minp;
  tmax=f->maxp==ErrVal?2*3.1415926535897932384L:f->maxp;
  double dx,dx2,dy,dy2,tg=tmin,t0,x0,y0,dr=f->dr,t1=tmin-(tmax-tmin),absc;
  PROperation pexprx=new ROperation(f->pexpr->NthMember(1)),pexprderx=new ROperation(f->pexprder->NthMember(1)),
    pexpry=new ROperation(f->pexpr->NthMember(2)),pexprdery=new ROperation(f->pexprder->NthMember(2));
  TCourbe*pcrb;
  for(t=tmin;t<tmax;t+=dr)if((y=pexpry->Val())!=ErrVal&&y<ylc+yech&&y>ylc-yech
			     &&(x=pexprx->Val())!=ErrVal&&x<xlc+xech&&x>xlc-xech){
    pcrb=new TCourbe;f->LCourbes.AddObject(pcrb);x0=x;y0=y;t0=t;
    for(dx=dx2=0,dy=dy2=absc=0;t!=t1&&y<ylc+yech&&y>ylc-yech&&x<xlc+xech&&x>xlc-xech
	  &&t>tg&&dy!=ErrVal&&y!=ErrVal&&dx!=ErrVal&&x!=ErrVal
	  &&((dx>=0&&dx2>=0)||(dx<=0&&dx2<=0)||fabs(dx-dx2)<1)
	  &&((dy>=0&&dy2>=0)||(dy<=0&&dy2<=0)||fabs(dy-dy2)<1);
	dx2=dx,dx=pexprderx->Val(),dy2=dy,dy=pexprdery->Val(),
	  dx=(dx==ErrVal?0:dx/xech),dy=(dy==ErrVal?0:dy/yech),t1=t,
	  t-=(dx||dy?dr/hypot(dx,dy):dr),x=pexprx->Val(),y=pexpry->Val(),
	  absc+=(t-t1)*hypot(dx*xech,dy*yech))
      {pcrb->AjouteDeb(x,y,absc);
      if(InterruptionToRepeat())goto fin;};
    for(x=x0,y=y0,t=t0,dx=dx2=0,dy=dy2=absc=0;t!=t1&&y<ylc+yech&&y>ylc-yech&&x<xlc+xech&&x>xlc-xech
	  &&t<tmax&&dy!=ErrVal&&y!=ErrVal&&dx!=ErrVal&&x!=ErrVal
	  &&((dx>=0&&dx2>=0)||(dx<=0&&dx2<=0)||fabs(dx-dx2)<1)
	  &&((dy>=0&&dy2>=0)||(dy<=0&&dy2<=0)||fabs(dy-dy2)<1);
	dx2=dx,dx=pexprderx->Val(),dy2=dy,dy=pexprdery->Val(),
	  dx=(dx==ErrVal?0:dx/xech),dy=(dy==ErrVal?0:dy/yech),t1=t,
	  t+=(dx||dy?dr/hypot(dx,dy):dr),x=pexprx->Val(),y=pexpry->Val(),
	  absc+=(t-t1)*hypot(dx*xech,dy*yech))
      {pcrb->AjouteFin(x,y,absc);
      if(InterruptionToRepeat())goto fin;};
    tg=t-dr;t1=tg;
  };
 fin:f->Calc=1;
}

void Fenetre::CalculeFonctionRAFT(TFonction*f)
{
  f->LCourbes.Destroy();double tmin,tmax;
  tmin=f->minp==ErrVal?0:f->minp;
  tmax=f->maxp==ErrVal?2*3.1415926535897932384L:f->maxp;
  double da,da2,dr,dr2,tg=tmin,t0,a0,r0,dp=f->dr,dt=dp,rmax=RMax(),
    rmin=-rmax,c,s,pech1,t1=tmin-(tmax-tmin),absc,a1,r1;
  PROperation pexprr=new ROperation(f->pexpr->NthMember(1)),pexprderr=new ROperation(f->pexprder->NthMember(1)),
    pexpra=new ROperation(f->pexpr->NthMember(2)),pexprdera=new ROperation(f->pexprder->NthMember(2));
  TCourbe*pcrb;
  for(t=tmin;t<tmax;t+=dp)if((a=pexpra->Val())!=ErrVal&&(r=pexprr->Val())!=ErrVal&&r<rmax&&r>rmin){
    pcrb=new TCourbe;f->LCourbes.AddObject(pcrb);a0=a;r0=r;t0=t;
    for(da=da2=0,dr=dr2=absc=0;t!=t1&&r<rmax&&r>rmin
	  &&t>tg&&da!=ErrVal&&a!=ErrVal&&dr!=ErrVal&&r!=ErrVal
	  &&fabs(da*dp)<31.4&&((da>=0&&da2>=0)||(da<=0&&da2<=0)||fabs(da-da2)<1)
	  &&(c=cos(a),s=sin(a),pech1=hypot(xech*c,yech*s),
	     ((dr>=0&&dr2>=0)||(dr<=0&&dr2<=0)||fabs(dr-dr2)<pech1));
	da2=da,da=pexprdera->Val(),dr2=dr,dr=pexprderr->Val(),
	  dt=(da!=ErrVal&&dr!=ErrVal&&(da*r||dr)?
	      dp/sqrt(dr*dr/(pech1*pech1)+da*da*r*r/(xech*xech*s*s+yech*yech*c*c)):dp),
	  dt=(dt<dp?dt:dp),t1=t,t-=dt,a1=a,r1=r,a=pexpra->Val(),r=pexprr->Val(),
	  absc-=hypot(r-r1,r*(a-a1)))
      {pcrb->AjouteDeb(r*c,r*s,absc);
      if(InterruptionToRepeat())goto fin;};
    for(t=t0,a=a0,r=r0,da=da2=absc=0,dr=dr2=0;t!=t1&&r<rmax&&r>rmin
	  &&t<tmax&&da!=ErrVal&&a!=ErrVal&&dr!=ErrVal&&r!=ErrVal
	  &&fabs(da*dp)<31.4&&((da>=0&&da2>=0)||(da<=0&&da2<=0)||fabs(da-da2)<1)
	  &&(c=cos(a),s=sin(a),pech1=hypot(xech*c,yech*s),
	     ((dr>=0&&dr2>=0)||(dr<=0&&dr2<=0)||fabs(dr-dr2)<pech1));
	da2=da,da=pexprdera->Val(),dr2=dr,dr=pexprderr->Val(),
	  dt=(da!=ErrVal&&dr!=ErrVal&&(da*r||dr)?
	      dp/sqrt(dr*dr/(pech1*pech1)+da*da*r*r/(xech*xech*s*s+yech*yech*c*c)):dp),
	  dt=(dt<dp?dt:dp),t1=t,t+=dt,a1=a,r1=r,a=pexpra->Val(),r=pexprr->Val(),
	  absc+=hypot(r-r1,r*(a-a1)))
      {pcrb->AjouteFin(r*c,r*s,absc);
      if(InterruptionToRepeat())goto fin;};
    tg=t-dp;t1=tg;
  };
 fin:f->Calc=1;
}

void Fenetre::TraceFonction(HDC dc,TFonction*pf)
{if(pf->Active)for(int j=0;j<!pf->LCourbes;j++)TraceCourbe(dc,&pf->LCourbes[j],pf->hp);
}

void Fenetre::TraceCourbe(HDC dc,TCourbe*c,HPEN hp)
{
  TPoint*ppoint=c->prem;
  if(ppoint==NULL)return;
  ShowWait();
  SelectObject(dc,hp);
  Go(dc,ppoint->x,ppoint->y);
  for(ppoint=ppoint->succ;ppoint!=NULL;ppoint=ppoint->succ)Line(dc,ppoint->x,ppoint->y);
  HideWait();
}

void Fenetre::TraceEqDiffYFX(HDC dc,double x0,double y0)
{
  double dx,z,z2,sgn,dx2,absc,dd;
  if(PFoncSel->minp==ErrVal){if(!FBornes)xmin=xlc-xech;}
  else xmin=(xlc-xech<PFoncSel->minp?PFoncSel->minp:xlc-xech);
  if(PFoncSel->maxp==ErrVal){if(!FBornes)xmax=xlc+xech;}
  else xmax=(xlc+xech>PFoncSel->maxp?PFoncSel->maxp:xlc+xech);
  if(!FBornes){ymax=ylc+yech;ymin=ylc-yech;};
  TCourbe*pcrb=new TCourbe;PFoncSel->LCourbes.AddObject(pcrb);
  SelectObject(dc,PFoncSel->hp);
  pcrb->AjouteFin(x0,y0,0);
  short i=0;if(dxsens||dysens)i=1;
  for(;i<2;i++){
    sgn=(i?1:-1);x=x0;y=y0;absc=0;dd=0;
    z2=PFoncSel->pexpr->Val();
    if(z2==ErrVal){
      y+=PFoncSel->dr*yech*sgn;z2=PFoncSel->pexpr->Val();absc+=yech*PFoncSel->dr;
      if(z2==ErrVal){MessageBeep(-1);break;};
      if(z2<0)sgn*=-1;if(i)pcrb->AjouteFin(x,y,absc);else pcrb->AjouteDeb(x,y,-absc);
    };
    Go(dc,x0,y0);
    dx2=PFoncSel->dr/hypot(1/xech,z2/yech);
    if(sgn*dx2*dxsens/(xech*xech)+dx2*z2*sgn*dysens/(yech*yech)<0)sgn=-sgn;
    do{
      z=PFoncSel->pexpr->Val();if(z!=ErrVal){
	dx=PFoncSel->dr/hypot(1/xech,z/yech);
	if(z2==ErrVal){
	  x+=dx*sgn;y+=dx*sgn*z;z2=z;dx2=dx;absc+=dx*hypot(1,z);
	}else	if(dx2&&fabs(z-z2)*dx/(2*dx2)>yech/xech){
	  if(z*z2<0){AnalyseEqDiffYFX(z,sgn,dx);if(!sgn)break;};
	  x+=dx*sgn;y+=dx*sgn*z;
	  z2=z;dx2=dx;absc+=dx*hypot(1,z);
	}else if(!dx2&&z*z2<0){
	  sgn*=-1;x+=dx*sgn;y+=dx*sgn*z;z2=z;dx2=dx;absc+=dx*hypot(1,z);
	}else{
	  x+=dx*sgn;y+=dx*sgn*(z+(z-z2)*dx/(2*dx2));absc+=dx*hypot(1,z);
	  z2=z;dx2=dx;
	};
      }else{
	if(z2==ErrVal||dx2==0||!PFoncSel->opt)break;
	x+=dx2*sgn;y+=dx2*sgn*z2;dx2=0;absc+=dx2*hypot(1,z2);
      };
      if(PFoncSel->TestPts&&TestePoint(pcrb,x,y,PFoncSel->dr/2))
	{if(i)pcrb->AjouteFin(x,y,absc);else pcrb->AjouteDeb(x,y,-absc);
	Line(dc,x,y);break;};
      if(i)pcrb->AjouteFin(x,y,absc);else pcrb->AjouteDeb(x,y,-absc);
      if(!IndLimCourbes)Line(dc,x,y);else{
	dd-=PFoncSel->dr;if(dd<=0){
	  dd=TestePointLim(x,y,PFoncSel->dr*1.5);if(!dd)break;
	};
      };
      if(!PFoncSel->TestPts&&PFoncSel->TestPtI&&
	 ((x-x0)*(x-x0)/(xech*xech)+(y-y0)*(y-y0)/(yech*yech))<=PFoncSel->dr*PFoncSel->dr/4){i=2;break;};
      if(PFoncSel->IntS){
	if(InterruptionNotToRepeat())break;
      };
    }while(x<xmax&&x>xmin&&y<ymax&&y>ymin);
    if(IndLimCourbes&&dd<=0)break;
  };
  if(!IndLimCourbes||dd>0)TraceCourbe(hdcMem,pcrb,PFoncSel->hp);
  if(IndLimCourbes&&dd>0)TraceCourbe(dc,pcrb,PFoncSel->hp);
  if(IndLimCourbes&&dd<=0)
    PFoncSel->LCourbes.DestroyObject(!PFoncSel->LCourbes-1);
}

void Fenetre::TraceEqDiffXFY(HDC dc,double x0,double y0)
{
  double dy,z,z2,sgn,dy2,absc,dd;
  if(PFoncSel->minp==ErrVal){if(!FBornes)ymin=ylc-yech;}
  else ymin=(ylc-yech<PFoncSel->minp?PFoncSel->minp:ylc-yech);
  if(PFoncSel->maxp==ErrVal){if(!FBornes)ymax=ylc+yech;}
  else ymax=(ylc+yech>PFoncSel->maxp?PFoncSel->maxp:ylc+yech);
  if(!FBornes){xmax=xlc+xech;xmin=xlc-xech;};
  TCourbe*pcrb=new TCourbe;PFoncSel->LCourbes.AddObject(pcrb);
  SelectObject(dc,PFoncSel->hp);
  pcrb->AjouteFin(x0,y0,0);
  short i=0;if(dxsens||dysens)i=1;
  for(;i<2;i++){
    sgn=(i?1:-1);x=x0;y=y0;absc=0;dd=0;
    Go(dc,x0,y0);
    z2=PFoncSel->pexpr->Val();
    if(z2==ErrVal){
      x+=PFoncSel->dr*xech*sgn;z2=PFoncSel->pexpr->Val();absc+=PFoncSel->dr*xech;
      if(z2==ErrVal){MessageBeep(-1);break;};
      if(z2<0)sgn*=-1;if(i)pcrb->AjouteFin(x,y,absc);else pcrb->AjouteDeb(x,y,-absc);
    };
    dy2=PFoncSel->dr/hypot(1/yech,z2/xech);
    if(sgn*dy2*dysens/(yech*yech)+dy2*z2*sgn*dxsens/(xech*xech)<0)sgn=-sgn;
    do{
      z=PFoncSel->pexpr->Val();if(z!=ErrVal){
	dy=PFoncSel->dr/hypot(1/yech,z/xech);
	if(z2==ErrVal){
	  y+=dy*sgn;x+=dy*sgn*z;z2=z;dy2=dy;absc+=dy*hypot(1,z);
	}else	if(dy2&&fabs(z-z2)*dy/(2*dy2)>xech/yech){
	  if(z*z2<0){AnalyseEqDiffXFY(z,sgn,dy);if(!sgn)break;};
	  y+=dy*sgn;x+=dy*sgn*z;z2=z;dy2=dy;absc+=dy*hypot(1,z);
	}else if(!dy2&&z*z2<0){
	  sgn*=-1;y+=dy*sgn;x+=dy*sgn*z;z2=z;dy2=dy;absc+=dy*hypot(1,z);
	}else{
	  y+=dy*sgn;x+=dy*sgn*(z+(z-z2)*dy/(2*dy2));
	  z2=z;dy2=dy;absc+=dy*hypot(1,z);
	};
      }else{
	if(z2==ErrVal||dy2==0||!PFoncSel->opt)break;
	y+=dy2*sgn;x+=dy2*sgn*z2;dy2=0;absc+=dy2*hypot(1,z2);
      };
      if(PFoncSel->TestPts&&TestePoint(pcrb,x,y,PFoncSel->dr/2))
	{if(i)pcrb->AjouteFin(x,y,absc);else pcrb->AjouteDeb(x,y,-absc);
	Line(dc,x,y);break;};
      if(i)pcrb->AjouteFin(x,y,absc);else pcrb->AjouteDeb(x,y,-absc);
      if(!IndLimCourbes)Line(dc,x,y);else{
	dd-=PFoncSel->dr;if(dd<=0){
	  dd=TestePointLim(x,y,PFoncSel->dr*1.5);if(!dd)break;
	};
      };
      if(!PFoncSel->TestPts&&PFoncSel->TestPtI&&
	 ((x-x0)*(x-x0)/(xech*xech)+(y-y0)*(y-y0)/(yech*yech))<=PFoncSel->dr*PFoncSel->dr/4){i=2;break;};
      if(PFoncSel->IntS){
	if(InterruptionNotToRepeat())break;      };
    }while(y<ymax&&y>ymin&&x<xmax&&x>xmin);
    if(IndLimCourbes&&dd<=0)break;
  };
  if(!IndLimCourbes||dd>0)TraceCourbe(hdcMem,pcrb,PFoncSel->hp);
  if(IndLimCourbes&&dd>0)TraceCourbe(dc,pcrb,PFoncSel->hp);
  if(IndLimCourbes&&dd<=0)
    PFoncSel->LCourbes.DestroyObject(!PFoncSel->LCourbes-1);
}

void Fenetre::TraceNiv(HDC dc,double x0,double y0,double zr)
{
  double dzdx,dzdy,dx,dy,z,n,z0,sgn,dr/*,dxAnal,dyAnal,dx0,dy0*/,absc;
  if(!FBornes){xmax=xlc+xech;xmin=xlc-xech;ymax=ylc+yech;ymin=ylc-yech;};
  TCourbe*pcrb=new TCourbe;PFoncSel->LCourbes.AddObject(pcrb);
  SelectObject(dc,PFoncSel->hp);
  dr=PFoncSel->dr;
  //dxAnal=0;dyAnal=0;
  x=x0;y=y0;
  if(zr==ErrVal)z0=PFoncSel->pexpr->Val();else z0=zr;
  if(z0==ErrVal){MessageBeep(-1);return;};
  dzdx=PFoncSel->pexprder->Val();dzdy=PFoncSel->pexprder2->Val();
  if((dzdx==ErrVal||dzdy==ErrVal)||(!(dzdx||dzdy)/*&&!Analyse(PFoncSel,x0,y0,0,0,dx0,dy0)*/))
    return;
  pcrb->AjouteFin(x0,y0,0);
  short i=0;if(dxsens||dysens)i=1;
  for(;i<2;i++){
    sgn=(i?1:-1);x=x0;y=y0;absc=0;
    Go(dc,x0,y0);dx=0;dy=0;n=0;
    if(-sgn*dzdy*dxsens/(xech*xech)+sgn*dzdx*dysens/(yech*yech)<0)sgn*=-1;
    do{
      dzdx=PFoncSel->pexprder->Val();dzdy=PFoncSel->pexprder2->Val();
      z=PFoncSel->pexpr->Val();
      if(z==ErrVal||dzdx==ErrVal||dzdy==ErrVal){
	if(!PFoncSel->opt||!n)break;
	x+=-sgn*dr*dy*xech;y+=sgn*dr*dx*yech;n=0;absc+=dr*hypot(dy*xech,dx*yech);
      }else{
	n=hypot(dzdx*xech,dzdy*yech);
	if(dzdx*dx*xech+dzdy*dy*yech<-n/2){if(!PFoncSel->opt)break;else sgn*=-1;};
	if(dzdx||dzdy){dx=dzdx/n*xech;dy=dzdy/n*yech;
	if(fabs(z-z0)>n*dr/2)break;
	x+=(-sgn*dr*dy-(z-z0)*dx/n)*xech;
	y+=(sgn*dr*dx-(z-z0)*dy/n)*yech;
	absc+=dr*hypot(dy*xech,dx*yech);
	}else if((dx||dy)&&PFoncSel->opt==1){
	  x+=-sgn*dr*dy*xech;
	  y+=sgn*dr*dx*yech;
	  dx=0;dy=0;absc+=dr*hypot(dy*xech,dx*yech);
	  /*			}else if(PFoncSel->opt==2){
				if(x==x0&&y==y0){x+=sgn*dr*dx0*xech;y+=sgn*dr*dy0*yech;dx=dy0;dy=-dx0;}else{
				if(!Analyse(PFoncSel,x,y,-dy,dx,dxAnal,dyAnal))break;
				x+=dr*dxAnal*xech;y+=dr*dyAnal*yech;dx=dyAnal*xech;dy=-dxAnal*yech;sgn=1;
				};*/
	}else break;
      };
      if(PFoncSel->TestPts&&TestePoint(pcrb,x,y,dr/2))
	{if(i)pcrb->AjouteFin(x,y,absc);else pcrb->AjouteDeb(x,y,-absc);
	Line(dc,x,y);break;};
      if(i)pcrb->AjouteFin(x,y,absc);else pcrb->AjouteDeb(x,y,-absc);
      Line(dc,x,y);
      if(!PFoncSel->TestPts&&PFoncSel->TestPtI&&
	 ((x-x0)*(x-x0)/(xech*xech)+(y-y0)*(y-y0)/(yech*yech))<=dr*dr/4){i=2;break;};
      if(PFoncSel->IntS){
	if(InterruptionNotToRepeat())break;      };
    }while(x<xmax&&x>xmin&&y<ymax&&y>ymin);
  };TraceCourbe(hdcMem,pcrb,PFoncSel->hp);
}

void Fenetre::TraceChamp(HDC dc,double x0,double y0)
{
  double dx,dy,dzdx,dzdy,dzdx2,dzdy2,sgn,dr,n,dx2,dy2,absc;
  if(!FBornes){xmax=xlc+xech;xmin=xlc-xech;ymax=ylc+yech;ymin=ylc-yech;};
  TCourbe*pcrb=new TCourbe;PFoncSel->LCourbes.AddObject(pcrb);
  SelectObject(dc,PFoncSel->hp);
  dr=PFoncSel->dr;
  pcrb->AjouteFin(x0,y0,0);
  short i=0;if(dxsens||dysens)i=1;
  for(;i<2;i++){
    sgn=(i?1:-1);x=x0;y=y0;absc=0;
    Go(dc,x0,y0);
    dzdx2=PFoncSel->pexprder->Val();dzdy2=PFoncSel->pexprder2->Val();
    if(dzdx2==ErrVal||dzdy2==ErrVal){MessageBeep(-1);break;};
    n=hypot(dzdx2/xech,dzdy2/yech);if(!n){MessageBeep(-1);break;};
    dx2=dzdx2/xech;dy2=dzdy2/yech;
    if(sgn*dx2*dxsens/xech+sgn*dy2*dysens/yech<0)sgn=-sgn;
    do{
      dzdx=PFoncSel->pexprder->Val();dzdy=PFoncSel->pexprder2->Val();
      if(dzdx==ErrVal||dzdy==ErrVal){
	if(!PFoncSel->opt||dzdx2==ErrVal||dzdy2==ErrVal)break;
	x+=dx*n*xech;y+=dy*n*yech;dzdx2=ErrVal;dzdy2=ErrVal;dx2=dx;dy2=dy;
	absc+=n*hypot(dx*xech,dy*yech);
      }else{
	if(dzdx2==ErrVal||fabs(dzdx-dzdx2)*xech>4)dzdx2=dzdx;
	if(dzdy2==ErrVal||fabs(dzdy-dzdy2)*yech>4)dzdy2=dzdy;
	dx=(dzdx+(dzdx-dzdx2)/2)/xech;dy=(dzdy+(dzdy-dzdy2)/2)/yech;
	if(!(dx||dy)){if(PFoncSel->opt){
	  dx=dzdx/xech;dy=dzdy/yech;if(!(dx||dy))break;
	}else break;
	};
	if(dx*dx2+dy*dy2<0){if(PFoncSel->opt)sgn*=-1;else break;};
	n=sgn*dr/hypot(dx,dy);
	x+=dx*n*xech;y+=dy*n*yech;absc+=n*hypot(dx*xech,dy*yech);
	dzdx2=dzdx;dzdy2=dzdy;dx2=dx;dy2=dy;
      };
      if(PFoncSel->TestPts&&TestePoint(pcrb,x,y,dr/2))
	{if(i)pcrb->AjouteFin(x,y,absc);else pcrb->AjouteDeb(x,y,-absc);
	Line(dc,x,y);break;};
      if(i)pcrb->AjouteFin(x,y,absc);else pcrb->AjouteDeb(x,y,-absc);
      Line(dc,x,y);
      if(!PFoncSel->TestPts&&PFoncSel->TestPtI&&
	 ((x-x0)*(x-x0)/(xech*xech)+(y-y0)*(y-y0)/(yech*yech))<=dr*dr/4){i=2;break;};
      if(PFoncSel->IntS){
	if(InterruptionNotToRepeat())break;      };
    }while(x<xmax&&x>xmin&&y<ymax&&y>ymin);
  };TraceCourbe(hdcMem,pcrb,PFoncSel->hp);
}

void Fenetre::TraceNiv2(HDC dc,double x0,double y0,double zr)
{
  double dzdx,dzdy,dx,dy,z,n,z0,sgn,dr/*,dxAnal,dyAnal,dx0,dy0*/,absc,dd;
  
  if(!FBornes){xmax=xlc+xech;xmin=xlc-xech;ymax=ylc+yech;ymin=ylc-yech;};
  TCourbe*pcrb=new TCourbe;PFoncSel->LCourbes.AddObject(pcrb);
  SelectObject(dc,PFoncSel->hp);
  dr=PFoncSel->dr;
  //dxAnal=0;dyAnal=0;
  x=x0;y=y0;r=hypot(x,y);if(x||y)a=atan2(y,x);else a=0;
  if(zr==ErrVal)z0=PFoncSel->pexpr->Val();else z0=zr;
  if(z0==ErrVal){MessageBeep(-1);return;};
  dzdx=PFoncSel->pexprder->Val();dzdy=PFoncSel->pexprder2->Val();
  if((dzdx==ErrVal||dzdy==ErrVal)||(!(dzdx||dzdy)/*&&!Analyse(PFoncSel,x0,y0,0,0,dx0,dy0)*/))
    return;
  pcrb->AjouteFin(x0,y0,0);
  short i=0;if(dxsens||dysens)i=1;
  for(;i<2;i++){
    sgn=(i?1:-1);x=x0;y=y0;r=hypot(x,y);if(x||y)a=atan2(y,x);else a=0;
    Go(dc,x0,y0);dx=0;dy=0;n=0;absc=0;dd=0;
    if(-sgn*dzdy*dxsens*yech/xech+sgn*dzdx*dysens*xech/yech<0)sgn=-sgn;
    do{
      r=hypot(x,y);if(x||y)a=atan2(y,x);
      dzdx=PFoncSel->pexprder->Val();dzdy=PFoncSel->pexprder2->Val();
      z=PFoncSel->pexpr->Val();
      if(z==ErrVal||dzdx==ErrVal||dzdy==ErrVal){
	if(!PFoncSel->opt||!n)break;
	x+=-sgn*dr*dy*xech;y+=sgn*dr*dx*yech;n=0;absc+=dr*hypot(dy*xech,dx*yech);
      }else{
	n=hypot(dzdx*xech,dzdy*yech);
	if(dzdx*dx*xech+dzdy*dy*yech<-n/2){if(!PFoncSel->opt)break;else sgn*=-1;};
	if(dzdx||dzdy){
	  dx=dzdx/n*xech;dy=dzdy/n*yech;
	  if(fabs(z-z0)>n*dr/2)break;
	  x+=(-sgn*dr*dy-(z-z0)*dx/n)*xech;
	  y+=(sgn*dr*dx-(z-z0)*dy/n)*yech;
	  absc+=dr*hypot(dy*xech,dx*yech);
	}else if((dx||dy)&&PFoncSel->opt==1){
	  x+=-sgn*dr*dy*xech;
	  y+=sgn*dr*dx*yech;
	  dx=0;dy=0;absc+=dr*hypot(dy*xech,dx*yech);
	  /*			}else if(PFoncSel->opt==2){
				if(x==x0&&y==y0){x+=sgn*dr*dx0*xech;y+=sgn*dr*dy0*yech;dx=dy0;dy=-dx0;}else{
				if(!Analyse(PFoncSel,x,y,-dy,dx,dxAnal,dyAnal))break;
				x+=dr*dxAnal*xech;y+=dr*dyAnal*yech;dx=dyAnal*xech;dy=-dxAnal*yech;sgn=1;
				};*/
	}else break;
      };
      if(PFoncSel->TestPts&&TestePoint(pcrb,x,y,dr/2))
	{if(i)pcrb->AjouteFin(x,y,absc);else pcrb->AjouteDeb(x,y,-absc);
	if(!IndLimCourbes)Line(dc,x,y);break;};
      if(i)pcrb->AjouteFin(x,y,absc);else pcrb->AjouteDeb(x,y,-absc);
      if(!IndLimCourbes)Line(dc,x,y);else{
	dd-=dr;if(dd<=0){
	  dd=TestePointLim(x,y,dr*1.5);if(!dd)break;
	};
      };
      if(!PFoncSel->TestPts&&PFoncSel->TestPtI&&
	 ((x-x0)*(x-x0)/(xech*xech)+(y-y0)*(y-y0)/(yech*yech))<=dr*dr/4){i=2;break;};
      if(PFoncSel->IntS){
	if(InterruptionNotToRepeat())break;      };
    }while(x<xmax&&x>xmin&&y<ymax&&y>ymin);
    if(IndLimCourbes&&dd<=0)break;
  };
  if(!IndLimCourbes||dd>0)TraceCourbe(hdcMem,pcrb,PFoncSel->hp);
  if(IndLimCourbes&&dd>0)TraceCourbe(dc,pcrb,PFoncSel->hp);
  if(IndLimCourbes&&dd<=0)
    PFoncSel->LCourbes.DestroyObject(!PFoncSel->LCourbes-1);
}

void Fenetre::TraceChamp2(HDC dc,double x0,double y0)
{
  double dx,dy,dzdx,dzdy,dzdx2,dzdy2,sgn,dr,n,dx2,dy2,absc,dd;
  if(!FBornes){xmax=xlc+xech;xmin=xlc-xech;ymax=ylc+yech;ymin=ylc-yech;};
  TCourbe*pcrb=new TCourbe;PFoncSel->LCourbes.AddObject(pcrb);
  SelectObject(dc,PFoncSel->hp);
  dr=PFoncSel->dr;
  pcrb->AjouteFin(x0,y0,0);
  short i=0;if(dxsens||dysens)i=1;
  for(;i<2;i++){
    sgn=(i?1:-1);x=x0;y=y0;r=hypot(x,y);if(x||y)a=atan2(y,x);else a=0;
    Go(dc,x0,y0);absc=0;dd=0;
    dzdx2=PFoncSel->pexprder->Val();dzdy2=PFoncSel->pexprder2->Val();
    if(dzdx2==ErrVal||dzdy2==ErrVal){MessageBeep(-1);break;};
    n=hypot(dzdx2/xech,dzdy2/yech);if(!n){MessageBeep(-1);break;};
    dx2=dzdx2/xech;dy2=dzdy2/yech;
    if(sgn*dx2*dxsens/xech+sgn*dy2*dysens/yech<0)sgn=-sgn;
    do{
      r=hypot(x,y);if(x||y)a=atan2(y,x);
      dzdx=PFoncSel->pexprder->Val();dzdy=PFoncSel->pexprder2->Val();
      if(dzdx==ErrVal||dzdy==ErrVal){
	if(!PFoncSel->opt||dzdx2==ErrVal||dzdy2==ErrVal)break;
	x+=dx*n*xech;y+=dy*n*yech;dzdx2=ErrVal;dzdy2=ErrVal;dx2=dx;dy2=dy;
	absc+=n*hypot(dx*xech,dy*yech);
      }else{
	if(dzdx2==ErrVal||fabs(dzdx-dzdx2)*xech>4)dzdx2=dzdx;
	if(dzdy2==ErrVal||fabs(dzdy-dzdy2)*yech>4)dzdy2=dzdy;
	dx=(dzdx+(dzdx-dzdx2)/2)/xech;dy=(dzdy+(dzdy-dzdy2)/2)/yech;
	if(!(dx||dy)){
	  if(PFoncSel->opt){dx=dzdx/xech;dy=dzdy/yech;if(!(dx||dy))break;
	  }else break;};
	if(dx*dx2+dy*dy2<0){if(PFoncSel->opt)sgn*=-1;else break;};
	n=sgn*dr/hypot(dx,dy);
	x+=dx*n*xech;y+=dy*n*yech;absc+=n*hypot(dx*xech,dy*yech);
	dzdx2=dzdx;dzdy2=dzdy;dx2=dx;dy2=dy;
      };
      if(PFoncSel->TestPts&&TestePoint(pcrb,x,y,dr/2))
	{if(i)pcrb->AjouteFin(x,y,absc);else pcrb->AjouteDeb(x,y,-absc);
	Line(dc,x,y);break;};
      if(i)pcrb->AjouteFin(x,y,absc);else pcrb->AjouteDeb(x,y,-absc);
      if(!IndLimCourbes)Line(dc,x,y);else{
	dd-=dr;if(dd<=0){
	  dd=TestePointLim(x,y,dr*1.5);if(!dd)break;
	};
      };
      if(!PFoncSel->TestPts&&PFoncSel->TestPtI&&
	 ((x-x0)*(x-x0)/(xech*xech)+(y-y0)*(y-y0)/(yech*yech))<=dr*dr/4){i=2;break;};
      if(PFoncSel->IntS){
	if(InterruptionNotToRepeat())break;      };
    }while(x<xmax&&x>xmin&&y<ymax&&y>ymin);
    if(IndLimCourbes&&dd<=0)break;
  };
  if(!IndLimCourbes||dd>0)TraceCourbe(hdcMem,pcrb,PFoncSel->hp);
  if(IndLimCourbes&&dd>0)TraceCourbe(dc,pcrb,PFoncSel->hp);
  if(IndLimCourbes&&dd<=0)
    PFoncSel->LCourbes.DestroyObject(!PFoncSel->LCourbes-1);
}
