/*

Copyright Yann OLLIVIER 1997-1999

This software may be freely distributed as is, including
this whole notice.

It may be modified, but any modification should include this whole notice as 
is and a description of the changes made.

This software may not be sold.

This software or any modified version of it may be freely used in free
programs. The program should include a copy of this whole notice. If you
want to use it in a program you sell, contact me

This software comes with absolutely no warranty.

*/

#include"eqdiff.h"

void SauveGdkColor(GdkColor color,FILE*fichier)
{
  int n;
  n=color.red;fwrite(&n,sizeof(n),1,fichier);
  n=color.green;fwrite(&n,sizeof(n),1,fichier);
  n=color.blue;fwrite(&n,sizeof(n),1,fichier);
}

GdkColor ChargeGdkColor(FILE*fichier)
{
  int n1,n2,n3;
  fread(&n1,sizeof(n1),1,fichier);
  fread(&n2,sizeof(n2),1,fichier);
  fread(&n3,sizeof(n3),1,fichier);
  return RGB(n1,n2,n3);
}

void SauveHPen(HPEN hp,FILE*fichier)
{
  SauveGdkColor(hp->color,fichier);
  int n=hp->width;fwrite(&n,sizeof(n),1,fichier);
}

HPEN ChargeHPen(FILE*fichier)
{
  int n1,n2,n3,n4;
  fread(&n1,sizeof(n1),1,fichier);
  fread(&n2,sizeof(n2),1,fichier);
  fread(&n3,sizeof(n3),1,fichier);
  fread(&n4,sizeof(n4),1,fichier);
  HPEN hp=CreatePen(PS_SOLID,n4,RGB(n1,n2,n3));
  return hp;
}

char* Fenetre::ChargeChaine(FILE*fichier)
{
  int n;fread(&n,sizeof(n),1,fichier);
  char*s=new char[n+1];
  for(int i=0;i<n;i++)fread(s+i,sizeof(char),1,fichier);
  s[n]=0;return s;
}

void Fenetre::SauveChaine(char*s,FILE*fichier)
{
  int n=strlen(s);fwrite(&n,sizeof(n),1,fichier);
  for(int i=0;i<n;i++)fwrite(s+i,sizeof(char),1,fichier);
}

TCourbe* Fenetre::ChargeCourbe(FILE*fichier)
{
  int n;fread(&n,sizeof(n),1,fichier);
  double x,y,t;TCourbe* pcrb=new TCourbe;
  for(int i=0;i<n;i++){
    fread(&x,sizeof(x),1,fichier);fread(&y,sizeof(y),1,fichier);
    fread(&t,sizeof(t),1,fichier);
    pcrb->AjouteFin(x,y,t);
  };
  return pcrb;
}

void Fenetre::SauveCourbe(TCourbe*pcrb,FILE*fichier)
{
  TPoint*ppoint=pcrb->prem;int n=0;
  while(ppoint!=NULL){n++;ppoint=ppoint->succ;};
  fwrite(&n,sizeof(n),1,fichier);
  for(ppoint=pcrb->prem;ppoint!=NULL;ppoint=ppoint->succ){
    fwrite(&ppoint->x,sizeof(ppoint->x),1,fichier);
    fwrite(&ppoint->y,sizeof(ppoint->y),1,fichier);
    fwrite(&ppoint->t,sizeof(ppoint->t),1,fichier);
  };
}

ROperation* Fenetre::ChargeOperation(FILE*fichier)
{
  char*s=ChargeChaine(fichier);
  if(!strcmp(s,"Erreur"))return new ROperation;
  RVar*ppvar[5];
  ppvar[0]=pxvar;ppvar[1]=pyvar;
  ppvar[2]=pavar;ppvar[3]=prvar;ppvar[4]=ptvar;
  return new ROperation(s,5,ppvar);
}

void Fenetre::SauveOperation(ROperation*pexpr,FILE*fichier)
{
  char*s=CopyStr(pexpr->Expr());SauveChaine(s,fichier);
}

TFonction* Fenetre::ChargeFonction(FILE*fichier)
{
  TFonction*pf=new TFonction;
  delete pf->nom;pf->nom=ChargeChaine(fichier);
  delete pf->pexpr;pf->pexpr=ChargeOperation(fichier);
  delete pf->pexprder;pf->pexprder=ChargeOperation(fichier);
  delete pf->pexprder2;pf->pexprder2=ChargeOperation(fichier);
  int n;fread(&n,sizeof(n),1,fichier);
  for(int i=0;i<n;i++)pf->LCourbes.AddObject(ChargeCourbe(fichier));
  fread(&pf->dr,sizeof(pf->dr),1,fichier);
  fread(&pf->minp,sizeof(pf->minp),1,fichier);
  fread(&pf->maxp,sizeof(pf->maxp),1,fichier);
  fread(&pf->Calc,sizeof(pf->Calc),1,fichier);
  fread(&pf->Active,sizeof(pf->Active),1,fichier);
  fread(&pf->Diff,sizeof(pf->Diff),1,fichier);
  fread(&pf->ZCalc,sizeof(pf->ZCalc),1,fichier);
  fread(&pf->opt,sizeof(pf->opt),1,fichier);
  fread(&pf->IntS,sizeof(pf->IntS),1,fichier);
  fread(&pf->TestPtI,sizeof(pf->TestPtI),1,fichier);
  fread(&pf->TestPts,sizeof(pf->TestPts),1,fichier);
  fread(&pf->t,sizeof(pf->t),1,fichier);
  DeleteObject(pf->hp);pf->hp=ChargeHPen(fichier);
  return pf;
}

void Fenetre::SauveFonction(TFonction*pf,FILE*fichier)
{
  SauveChaine(pf->nom,fichier);
  SauveOperation(pf->pexpr,fichier);
  SauveOperation(pf->pexprder,fichier);
  SauveOperation(pf->pexprder2,fichier);
  int n=!pf->LCourbes;fwrite(&n,sizeof(n),1,fichier);
  for(int i=0;i<n;i++)SauveCourbe(&pf->LCourbes[i],fichier);
  fwrite(&pf->dr,sizeof(pf->dr),1,fichier);
  fwrite(&pf->minp,sizeof(pf->minp),1,fichier);
  fwrite(&pf->maxp,sizeof(pf->maxp),1,fichier);
  fwrite(&pf->Calc,sizeof(pf->Calc),1,fichier);
  fwrite(&pf->Active,sizeof(pf->Active),1,fichier);
  fwrite(&pf->Diff,sizeof(pf->Diff),1,fichier);
  fwrite(&pf->ZCalc,sizeof(pf->ZCalc),1,fichier);
  fwrite(&pf->opt,sizeof(pf->opt),1,fichier);
  fwrite(&pf->IntS,sizeof(pf->IntS),1,fichier);
  fwrite(&pf->TestPtI,sizeof(pf->TestPtI),1,fichier);
  fwrite(&pf->TestPts,sizeof(pf->TestPts),1,fichier);
  fwrite(&pf->t,sizeof(pf->t),1,fichier);
  SauveHPen(pf->hp,fichier);
}

void Fenetre::Load()
{
  char *nom=FileSelDialog();if(nom==NULL)return;
  ShowWait();
  FILE *fichier;
  fichier=fopen(nom,"rb");
  if(fichier!=NULL){
    int i;
    fseek(fichier,0,SEEK_SET);
    LFonctions.Destroy();
    fread(&xech,sizeof(xech),1,fichier);
    fread(&yech,sizeof(yech),1,fichier);
    fread(&xlc,sizeof(xlc),1,fichier);
    fread(&ylc,sizeof(ylc),1,fichier);
    fread(&xaxe,sizeof(xaxe),1,fichier);
    fread(&yaxe,sizeof(yaxe),1,fichier);
    fread(&xgrad,sizeof(xgrad),1,fichier);
    fread(&ygrad,sizeof(ygrad),1,fichier);
    bgcolor=ChargeGdkColor(fichier);
    DeleteObject(axep);axep=ChargeHPen(fichier);
    int NFonc;fread(&NFonc,sizeof(NFonc),1,fichier);
    for(i=0;i<NFonc;i++)LFonctions.AddObject(ChargeFonction(fichier));
    fclose(fichier);
    xcurs=ErrVal;ycurs=ErrVal;
    PFoncSel=&LFonctions[0];
    Contexte=0;
    PSelCourbeFonc=NULL;SelCourbe=-1;
    char* s=new char[1];s[0]=0;
    FoncSelList=g_list_append(NULL,s);
    for(i=0;i<NFonc;i++)if(LFonctions[i].Diff)
      FoncSelList=g_list_append(FoncSelList,LFonctions[i].nom);
    gtk_combo_set_popdown_strings(GTK_COMBO(FoncSelL),FoncSelList);
    gtk_widget_set_sensitive(PanoramaB,FALSE);
    gtk_widget_set_sensitive(LimCurvesB,FALSE);
    gtk_widget_set_sensitive(FamilyB,FALSE);
    gtk_widget_set_sensitive(LevelB,FALSE);
    gtk_widget_set_sensitive(CrossB,FALSE);
    gtk_widget_set_sensitive(InflexB,FALSE);
    gtk_widget_set_sensitive(CrbDelB,FALSE);
    gtk_widget_set_sensitive(FoncDelB,FALSE);
    gtk_clist_freeze(GTK_CLIST(FList));
    gtk_clist_clear(GTK_CLIST(FList));
    for(i=0;i<NFonc;i++)
      gtk_clist_append(GTK_CLIST(FList),&LFonctions[i].nom);
    gtk_clist_thaw(GTK_CLIST(FList));
    gtk_clist_select_row(GTK_CLIST(FList),0,0);
    GdkColormap *colormap;
    colormap = gdk_window_get_colormap (drawing_area->window);
    gdk_color_alloc (colormap, &bgcolor);
    gdk_color_alloc(colormap,&axep->color);
    for(i=0;i<!LFonctions;i++)gdk_color_alloc(colormap,&LFonctions[i].hp->color);
    Redraw();
  }else MessageBox("Open a file","Invalid file");
  HideWait();
}

void Fenetre::Save()
{
  char* nom=FileSelDialog();
  if(nom==NULL)return;
  ShowWait();
  FILE *fichier;
  fichier=fopen(nom,"wb");
  if(fichier!=NULL){
    fseek(fichier,0,SEEK_SET);
    fwrite(&xech,sizeof(xech),1,fichier);
    fwrite(&yech,sizeof(yech),1,fichier);
    fwrite(&xlc,sizeof(xlc),1,fichier);
    fwrite(&ylc,sizeof(ylc),1,fichier);
    fwrite(&xaxe,sizeof(xaxe),1,fichier);
    fwrite(&yaxe,sizeof(yaxe),1,fichier);
    fwrite(&xgrad,sizeof(xgrad),1,fichier);
    fwrite(&ygrad,sizeof(ygrad),1,fichier);
    SauveGdkColor(bgcolor,fichier);
    SauveHPen(axep,fichier);
    int NFonc=!LFonctions;fwrite(&NFonc,sizeof(NFonc),1,fichier);
    for(int i=0;i<NFonc;i++)SauveFonction(&LFonctions[i],fichier);
    fclose(fichier);
  }else MessageBox("Save functions","Save failed");
  HideWait();
}

int Fenetre::GetPixelColor(guint32 n,char flag)
{
  if(n==bgcolor.pixel)return (flag?0:1);
  if(n==axep->color.pixel)return 2;
  int i;
  for(i=0;i<!LFonctions;i++)
    if(n==LFonctions[i].hp->color.pixel)return i+3;
  return (flag?0:1);
}

void Fenetre::SaveImageXPM()
{
  char* Nom=FileSelDialog();
  if(Nom==NULL)return;
  FILE*f=fopen(Nom,"wb");
  if(f!=NULL){
    gint w=drawing_area->allocation.width,
      h=drawing_area->allocation.height,
      x,y;guint32 n;int i;
      GdkImage*img=gdk_image_get(hbmMem,0,0,w,h);
      y=0;
      char flag;
      if(AskDialog("Save as xpm","Transparent background ?")==AskDialog_Yes)flag=1;else flag=0;
      ShowWait();
      char s[70]="";
      sprintf(s,"/* XPM */\nstatic char *image[] = {\n");
      fwrite(s,sizeof(char),strlen(s),f);
      sprintf(s,"\"%i %i %i 6\",\n",w,h,!LFonctions+3);
      fwrite(s,sizeof(char),strlen(s),f);
      sprintf(s,"\"a00000 c None\",\n\"a00001 c #%.2X%.2X%.2X\"",bgcolor.red/256,bgcolor.green/256,bgcolor.blue/256);
      fwrite(s,sizeof(char),strlen(s),f);
      sprintf(s,",\n\"a00002 c #%.2X%.2X%.2X\"",axep->color.red/256,axep->color.green/256,axep->color.blue/256);
      fwrite(s,sizeof(char),strlen(s),f);
      for(i=0;i<!LFonctions;i++){
	sprintf(s,",\n\"a%.5i c #%.2X%.2X%.2X\"",i+3,LFonctions[i].hp->color.red/256,LFonctions[i].hp->color.green/256,LFonctions[i].hp->color.blue/256);
	fwrite(s,sizeof(char),strlen(s),f);
      }
      for(y=0;y<h;y++){
	sprintf(s,",\n\"");
	fwrite(s,sizeof(char),strlen(s),f);
	for(x=0;x<w;x++){
	  n=gdk_image_get_pixel(img,x,y);
	  sprintf(s,"a%.5i",GetPixelColor(n,flag));
	  fwrite(s,sizeof(char),strlen(s),f);
	}
	sprintf(s,"\"");
	fwrite(s,sizeof(char),strlen(s),f);
      }
      sprintf(s,"\n};\n");
      fwrite(s,sizeof(char),strlen(s),f);
  }else MessageBox("Save as xpm","Save failed");
  fclose(f);
  HideWait();
}


void Fenetre::SaveImagePPM()
{
  char* Nom=FileSelDialog();
  if(Nom==NULL)return;
  ShowWait();
  gint w=drawing_area->allocation.width,
    h=drawing_area->allocation.height,
    x,y;guint32 n;int i;GdkColor*color;
  GdkImage*img=gdk_image_get(hbmMem,0,0,w,h);
  y=0;
  FILE*f=fopen(Nom,"wb");
  if(f!=NULL){
    char s[30]="";
    sprintf(s,"P3 %i %i 255 \n",w,h);
    fwrite(s,sizeof(char),strlen(s),f);
    for(y=0;y<h;y++){
      for(x=0;x<w;x++){
	n=gdk_image_get_pixel(img,x,y);
	if(n==bgcolor.pixel)color=&bgcolor;
	else if(n==axep->color.pixel)color=&axep->color;
	else{
	  for(i=0;i<!LFonctions;i++)
	    if(n==LFonctions[i].hp->color.pixel){color=&LFonctions[i].hp->color;break;}
	  if(i==!LFonctions)color=&bgcolor;
	}
	sprintf(s,"%i %i %i  ",color->red/256,color->green/256,color->blue/256);
	fwrite(s,sizeof(char),strlen(s),f);
      }
      sprintf(s,"\n");
      fwrite(s,sizeof(char),strlen(s),f);
    }
    fclose(f);
  }else MessageBox("Save as PPM","Save failed");
  HideWait();
}

void Fenetre::Merge()
{
  char* nom=FileSelDialog();
  if(nom==NULL)return;
  ShowWait();
  FILE *fichier;
  fichier=fopen(nom,"rb");
  if(fichier!=NULL){
    fseek(fichier,0,SEEK_SET);
    double buf;char Ind=0;
    fread(&buf,sizeof(buf),1,fichier);if(buf!=xech)Ind=1;
    fread(&buf,sizeof(buf),1,fichier);if(buf!=yech)Ind=1;
    fread(&buf,sizeof(buf),1,fichier);if(buf!=xlc)Ind=1;
    fread(&buf,sizeof(buf),1,fichier);if(buf!=ylc)Ind=1;
    fread(&buf,sizeof(buf),1,fichier);
    fread(&buf,sizeof(buf),1,fichier);
    fread(&buf,sizeof(buf),1,fichier);
    fread(&buf,sizeof(buf),1,fichier);
    GdkColor color=ChargeGdkColor(fichier);
    HPEN hp=ChargeHPen(fichier);DeleteObject(hp);
    if(Ind)MessageBox("Merge from file","The file to merge has not the same zoom parameters as the current window.\n This may cause unexpected display.");
    int NFonc,i,j;fread(&NFonc,sizeof(NFonc),1,fichier);
    TList<TFonction> LFonctions2=*new TList<TFonction>;
    for(i=0;i<NFonc;i++)LFonctions2.AddObject(ChargeFonction(fichier));
    fclose(fichier);
    char* Texte;
    for(i=1;i<NFonc;i++){
      j=0;Ind=1;
      while(Ind&&j<!LFonctions){
	Texte=new char[strlen(LFonctions2[i].nom+2)];
	sprintf(Texte,"%s",LFonctions2[i].nom);
	for(j=0;j<!LFonctions&&strcmp(LFonctions2[i].nom,LFonctions[j].nom);j++);
	if(j<!LFonctions){
	  char*s;
	  Ind=(InputDialog("Merge from file","This function bears a preoccupied name. New name: (no answer will discard it)",Texte,&s))==InputDialog_OK?1:0;
	  if(Ind)LFonctions2[i].nom=CopyStr(s);
	};
      };
      if(Ind)LFonctions.AddObject(&LFonctions2[i]);
    };
    Contexte=0;
    for(i=1;i<NFonc;i++)if(LFonctions2[i].Diff)
      FoncSelList=g_list_append(FoncSelList,LFonctions2[i].nom);
    gtk_combo_set_popdown_strings(GTK_COMBO(FoncSelL),FoncSelList);
    gtk_widget_set_sensitive(PanoramaB,FALSE);
    gtk_widget_set_sensitive(LimCurvesB,FALSE);
    gtk_widget_set_sensitive(FamilyB,FALSE);
    gtk_widget_set_sensitive(LevelB,FALSE);
    gtk_widget_set_sensitive(CrossB,FALSE);
    gtk_widget_set_sensitive(InflexB,FALSE);
    gtk_widget_set_sensitive(CrbDelB,FALSE);
    gtk_widget_set_sensitive(FoncDelB,FALSE);
    gtk_clist_freeze(GTK_CLIST(FList));
    for(i=1;i<NFonc;i++)
      gtk_clist_append(GTK_CLIST(FList),&LFonctions2[i].nom);
    gtk_clist_thaw(GTK_CLIST(FList));
    GdkColormap *colormap;
    colormap = gdk_window_get_colormap (drawing_area->window);
    for(i=1;i<!LFonctions2;i++)gdk_color_alloc(colormap,&LFonctions2[i].hp->color);
    Redraw();
  }else MessageBox("Merge from file","Invalid file");
  HideWait();
}
