/*

Copyright Yann OLLIVIER 1996-1999

This software may be freely distributed as is, including
this whole notice.

It may be modified, but any modification should include this whole notice as 
is and a description of the changes made.

This software may not be sold.

This software or any modified version of it may be freely used in free
programs. The program should include a copy of this whole notice. If you
want to use it in a program you sell, contact me

This software comes with absolutely no warranty.

*/

#ifndef _LISTS_H
#define _LISTS_H

//Class definitions for lists of ptrs on objects T
template<class T>
class TList{
	int size;
	char DoubleSize();
	char ReduceSize();
 public:
  T  *  *PList;
  int num;
  TList(int,T **);
  TList(const TList<T>&);
  inline TList();
  ~TList(){if(size)delete[] PList;};
  T & operator[](int i)const{return *PList[i];};
  int operator!()const{return num;};
  TList<T>& operator=(const TList<T>&);
  char AddObject(T *,int n);char AddObject(T *PObj){return AddObject(PObj,num);};
	char AddList(const TList<T>&,int n);char AddList(const TList<T>&l){return AddList(l,num);};
  char CopyObject(const T&,int n);char CopyObject(const T& Obj){return CopyObject(Obj,num);};
 	char CopyList(const TList<T>&,int n);char CopyList(const TList<T>&l){return CopyList(l,num);};
	char InsertSpace(int,int);char InsertSpace(int p){return InsertSpace(p,num);};
	char DelObject(int);
	void Delete();
  char DestroyObject(int);
  void Destroy();
};

template<class T>
TList<T>::TList()
{
  num=0;size=2;
  PList=new T *[2];
}

template<class T>
TList<T>::TList(int n,T **PListp)
{
  num=n;size=n;
  if(n)PList=new T  *[n];
  int i;
  for(i=0;i<n;i++)PList[i]=PListp[i];
}

template<class T>
TList<T>::TList(const TList<T>& ListInit)
{
  num=ListInit.num;size=num;
  if(num)PList=new T *[num];
  int i;
  for(i=0;i<num;i++)PList[i]=new T(ListInit[i]);
}

template<class T>
TList<T>& TList<T>::operator=(const TList<T>& ListInit)
{
	if(size)delete[]PList;
  num=ListInit.num;size=num;
  if(num)PList=new T  *[num];
  int i;
  for(i=0;i<num;i++)
    PList[i]=new T(ListInit[i]);
  return *this;
}

template<class T>
char TList<T>::DoubleSize()
{
 int nsize=(size==0?2:2*size);
 T**PList2=new T*[nsize];
 if(PList2==NULL)return 0;
 int i;
 for(i=0;i<num;i++)PList2[i]=PList[i];
 if(size)delete[]PList;
 PList=PList2;
 size=nsize;
 return 1;
}

template<class T>
char TList<T>::ReduceSize()
{
 if(size==num)return 0;
 T**PList2=new T*[num];
 if(PList2==NULL)return 0;
 int i;
 for(i=0;i<num;i++)PList2[i]=PList[i];
 if(size)delete[]PList;
 PList=PList2;
 size=num;return 1;
}

template<class T>
char TList<T>::AddObject(T *PObject,int n)
{
  if(n<0||n>num)return 0;
	int i=1;
	while(num+1>size)i=DoubleSize();
  if(!i)return 0;
  for(i=num;i>n;i--)PList[i]=PList[i-1];
  PList[n]=PObject;
  num++;
  return 1;
} 

template<class T>
char TList<T>::AddList(const TList<T>&list,int n)
{
  if(n<0||n>num)return 0;
	int num2=!list;if(!num2)return 1;
	int i=1;
	while(num+num2>size)i=DoubleSize();
	if(!i)return 0;
  for(i=num+num2-1;i>=n+num2;i--)PList[i]=PList[i-num2];
	for(i=n;i<n+num2;i++)PList[i]=list.PList[i-n];
  num+=num2;
  return 1;
}  

template<class T>
char TList<T>::CopyObject(const T& Object,int n)
{
  if(n<0||n>num)return 0;
	int i=1;
	while(num+1>size)i=DoubleSize();
  if(!i)return 0;
  for(i=num;i>n;i--)PList[i]=PList[i-1];
  PList[n]=new T(Object);
  num++;
  return 1;
}  

template<class T>
char TList<T>::CopyList(const TList<T>&list,int n)
{
  if(n<0||n>num)return 0;
	int num2=!list;if(!num2)return 1;
	int i=1;
	while(num+num2>size)i=DoubleSize();
	if(!i)return 0;
  for(i=num+num2-1;i>=n+num2;i--)PList[i]=PList[i-num2];
	for(i=n;i<n+num2;i++)PList[i]=new T(list[i-n]);
  num+=num2;
  return 1;
}  

template<class T>
char TList<T>::DelObject(int n)
{
  if(num==0||n>=num||n<0)return 0;
  int i;
  for(i=n;i<num-1;i++)PList[i]=PList[i+1];
  num--;
	if(num<size/4)ReduceSize();
  return 1;
}  

template<class T>
char TList<T>::InsertSpace(int p,int n)
{
 if(n<0||n>num)return 0;
 int i;
 if(p+num>size){
	 T**PList2=new T*[p+num];
	 if(PList2==NULL)return 0;
	 for(i=0;i<n;i++)PList2[i]=PList[i];
	 for(i=n;i<n+p;i++)PList2[i]=new T;
	 for(i=n+p;i<num+p;i++)PList2[i]=PList[i-p];
	 if(size)delete[]PList;
	 PList=PList2;
	 size=num+p;
	 num+=p;
 }else{
	 for(i=num+p-1;i>=n+p;i--)PList[i]=PList[i-p];
	 for(i=n;i<n+p;i++)PList[i]=new T;
	 num+=p;
 }
 return 1;
}

template<class T>
char TList<T>::DestroyObject(int n)
{
  if(num==0||n>=num||n<0)return 0;
  delete PList[n];
  int i;
  for(i=n;i<num-1;i++)PList[i]=PList[i+1];
  num--;
 	if(num<size/4)ReduceSize();
  return 1;
}

template<class T>
void TList<T>::Delete()
{
 if(size)delete[]PList;num=0;size=0;
}

template<class T>
void TList<T>::Destroy()
{
  int i;
  for(i=0;i<num;i++)delete PList[i];
  if(size)delete[]PList;num=0;size=0;
}



#endif
